local buttonToLoadTable = {
	["DownLeft"] = "_DownLeft";
	["UpLeft"] = "_UpLeft";
	["Center"] = "_Center";
	["UpRight"] = "_UpLeft";
	["DownRight"] = "_DownLeft";
}

local t = Def.ActorFrame{};


local pieces = {
	
	upleft = {
		size = (math.random() + 1) * 0.1;
		x = -16;
		y = -16;
		windMin = -96;
		windMax = -32;
		bounceMin = -70;
		bounceMax = -40;
	};

	up = {
		size = (math.random() + 1) * 0.15;
		x = 0;
		y = -24;
		windMin = -64;
		windMax = 64;
		bounceMin = -70;
		bounceMax = -40;
	};

	upright = {
		size = (math.random() + 1) * 0.1;
		x = 16;
		y = -16;
		windMin = 32;
		windMax = 96;
		bounceMin = -70;
		bounceMax = -40;
	};

	left = {
		size = (math.random() + 1) * 0.15;
		x = -24;
		y = 0;
		windMin = -96;
		windMax = -32;
		bounceMin = -50;
		bounceMax = -20;
	};

	center = {
		size = 0.4;
		x = 0;
		y = 0;
		windMin = -64;
		windMax = 64;
		bounceMin = -50;
		bounceMax = -20;
	};

	right = {
		size = (math.random() + 1) * 0.15;
		x = 24;
		y = 0;
		windMin = 32;
		windMax = 96;
		bounceMin = -50;
		bounceMax = -20;
	};

	downleft = {
		size = (math.random() + 1) * 0.1;
		x = -16;
		y = 16;
		windMin = -96;
		windMax = -32;
		bounceMin = -30;
		bounceMax = 0;
	};

	down = {
		size = (math.random() + 1) * 0.1;
		x = 0;
		y = 24;
		windMin = -64;
		windMax = 64;
		bounceMin = -30;
		bounceMax = 0;
	};

	downright = {
		size = (math.random() + 1) * 0.1;
		x = 16;
		y = 16;
		windMin = 32;
		windMax = 96;
		bounceMin = -30;
		bounceMax = 0;
	};

};

for key,piece in pairs(pieces) do
	-- Rotating the actor also rotates wind, so:
	if Var "Button" == 'UpRight'
	or Var "Button" == 'DownRight'
	then
		piece.x = -piece.x;
		piece.windMin, piece.windMax = -(piece.windMax), -(piece.windMin);
	end
	--
	local u = Def.ActorFrame{
		InitCommand=cmd(x,piece.x;y,0);
		W1Command=cmd(playcommand,"Move");
		W2Command=cmd(playcommand,"Move");
		W3Command=cmd(playcommand,"Move");
		HeldCommand=cmd(playcommand,"Move");
		MoveCommand=function(self)
			local deltax = math.random() * (piece.windMax - piece.windMin) + piece.windMin;
			self:finishtweening();
			self:x(piece.x);
			self:diffusealpha(1);
			self:linear(0.4);
			self:x(piece.x + (0.8 * deltax));
			self:diffusealpha(1);
			self:linear(0.1);
			self:x(piece.x + deltax);
			self:diffusealpha(0);
			self:sleep(0);
		end;
		NOTESKIN:LoadActor(buttonToLoadTable[Var "Button"], "Piece")..{
			InitCommand=cmd(
				-- animate,false;
				-- setstate,3;
				x,0;
				y,piece.y;
				diffusealpha,0;
				zoom,piece.size;
			); 
			W1Command=cmd(playcommand,"Pop");
			W2Command=cmd(playcommand,"Pop");
			W3Command=cmd(playcommand,"Pop");
			W4Command=cmd();
			W5Command=cmd();
			HoldingOnCommand=cmd();
			--HitMineCommand=cmd(playcommand,"Pop");
			HeldCommand=cmd(playcommand,"Pop");
			PopCommand=function(self)
				self:finishtweening();
				self:y(piece.y);
				self:diffusealpha(1);

				self:decelerate(0.2);
				self:y(math.random() * (piece.bounceMax - piece.bounceMin) + piece.bounceMin);
	
				self:accelerate(0.3);
				self:y(piece.y + 32);
			end;
		}
	};
	t[#t+1] = u;
end;

t[#t+1] = Def.Sprite{
	Texture=NOTESKIN:GetPath( 'Explosion', 'Glow' );
	InitCommand=cmd(
		blend,"BlendMode_Add";
		diffusealpha,0;
	);
	W1Command=cmd(playcommand,"Glow");
	W2Command=cmd(playcommand,"Glow");
	W3Command=cmd(playcommand,"Glow");
	HoldingOnCommand=cmd(playcommand,"Glow");
	HeldCommand=cmd(playcommand,"Glow");
	GlowCommand=cmd(
		finishtweening;
		rotationz,math.random(0,360);
		zoom,.8;
		diffusealpha,1;
		decelerate,.3;
		diffusealpha,0;
		zoom,1.25;
	);
};
return t;